/*
=========================================================================
	STRLIST.H (Version 1.01)
		Interface to an immutable string list class.
	Copyright (c) 2003-2004 by Daniel R. Collins. All rights reserved.
  You may freely copy this document, if copyright notice is maintained.
=========================================================================
*/

#ifndef STRLIST_H
#define STRLIST_H


/*
----------------------------------------
  One string in a list.
----------------------------------------
*/

class StringNode
	{
	public:
		StringNode	(const char *s);
		~StringNode	(void);

    StringNode*	getNext (void);
    const char* getString (void);
		void				setNext (StringNode *next);

	private:
		char *string;
		StringNode *next;
	};


/*
----------------------------------------
  A list of many strings.
----------------------------------------
*/

class StringList
	{
	public:
		StringList  (void);
		~StringList (void);

    void        appendString (const char *s);
		int         getNumStrings (void);
		const char* getString (int i);

	protected:
		StringNode* getNode (int i);

	private:
		int numStrings;
		StringNode *firstString;
	};


#endif

